#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/mman.h>
#include <unistd.h>
#include <fcntl.h>

#define DELTA 0x3c5428

static unsigned int cst1[] = {0x93CC7820, 0x3850C1b4, 0x9C43DCD5, 0x24F82506};
static unsigned int cst2[] = {0x00070E15, 0x1C232A31, 0x383F464D, 0x545b6269};
static unsigned int key[]  = {0x612E7270, 0x6766722E, 0x666E632E, 0x2E76662E, 0x76706E73, 0x66407279, 0x70766766, 0x7465622E};
static unsigned int user[] = {0x4a3a2a1a, 0x8a7a6a5a, 0x4b3b2b1b, 0x8b7b6b5b, 0x4c3c2c1c, 0x8c7c6c5c, 0x4d3d2d1d, 0x8d7d6d5d};

static unsigned int z0 = 0;
static unsigned int z1 = 0;
static unsigned int z2 = 0;
static unsigned int z3 = 0;
static unsigned int z4 = 0;
static unsigned int z5 = 0;
static unsigned int z6 = 0;
static unsigned int z7 = 0;
static unsigned int z8 = 0;
static unsigned int z9 = 0;
static unsigned int za = 0;
static unsigned int zb = 0;
static unsigned int zc = 0;
static unsigned int zd = 0;
static unsigned int ze = 0;
static unsigned int zf = 0;

char *data = NULL;
unsigned int data_size = 0;

void* prep_read(void *p) {
    return (void *)(&data[(long)p - DELTA]);
}__attribute__((used))

unsigned int kiwi(unsigned int in) {
	unsigned int tmp[8] = {0};
    unsigned int out;
	asm __volatile__ (
			"mov 		x21,%[in];"
			"and        x19,x21,#0xfffffff0;"
			"and        w21,w21,#0xf;"
			"add        x0,x19,#0x413, LSL #12;"
			"ld1        {v0.4s},%[cst1];"
			"rev32      v0.16b,v0.16b;"
			"ld1        {v1.4s},%[cst2];"
            "mov        v2.s[0x0],w19;"
            "mov        v2.s[0x1],w19;"
            "mov        v2.s[0x2],w19;"
            "mov        v2.s[0x3],w19;"
            "eor        v1.16b,v1.16b,v2.16b;"
            "sm4ekey    v0.4s,v0.4s,v1.4s;"
            "mov        v1.s[0x0],v0.s[0x3];"
            "mov        v1.s[0x1],v0.s[0x2];"
            "mov        v1.s[0x2],v0.s[0x1];"
            "mov        v1.s[0x3],v0.s[0x0];"
			"bl	    	prep_read;"
            "ld1        {v0.4s},[x0];"
            "rev32      v0.16b,v0.16b;"
            "sm4e       v0.4s,v1.4s;"
            "rev32      v0.16b,v0.16b;"
            "mov        v1.s[0x0],v0.s[0x3];"
            "mov        v1.s[0x1],v0.s[0x2];"
            "mov        v1.s[0x2],v0.s[0x1];"
            "mov        v1.s[0x3],v0.s[0x0];"

            "mov        x20,%[tmp];"
            "st1        {v1.4s},[x20];"

			"cmp        w21,#0xc;"
			"b.ls       LAB_00000fb0;"

			"add        x0,x19,#0x413, LSL #12;"
			"add        w1,w19,#0x10;"
			"add        x0,x0,#0x10;"
			"add        x3,x20,#0x10;"
			"ld1        {v0.4s},%[cst1];"
			"rev32      v0.16b,v0.16b;"
			"ld1        {v1.4s},%[cst2];"
			"mov        v2.s[0x0],w1;"
			"mov        v2.s[0x1],w1;"
			"mov        v2.s[0x2],w1;"
			"mov        v2.s[0x3],w1;"
			"eor        v1.16b,v1.16b,v2.16b;"
			"sm4ekey    v0.4s,v0.4s,v1.4s;"
			"mov        v1.s[0x0],v0.s[0x3];"
			"mov        v1.s[0x1],v0.s[0x2];"
			"mov        v1.s[0x2],v0.s[0x1];"
			"mov        v1.s[0x3],v0.s[0x0];"
			"bl	    	prep_read;"
			"ld1        {v0.4s},[x0];"
			"rev32      v0.16b,v0.16b;"
			"sm4e       v0.4s,v1.4s;"
			"rev32      v0.16b,v0.16b;"
			"mov        v1.s[0x0],v0.s[0x3];"
			"mov        v1.s[0x1],v0.s[0x2];"
			"mov        v1.s[0x2],v0.s[0x1];"
			"mov        v1.s[0x3],v0.s[0x0];"
            "st1        {v1.4s},[x3];"

        "LAB_00000fb0:"
            "and        x1,x21,#0xff;"
            "ldr        %w[out],[x20, x1, LSL #0x0];"

			:[out] "=r"(out)
			:[in] "wr"(in), [cst1] "m"(cst1), [cst2] "m"(cst2), [tmp] "rm"(tmp) 
            : "x1", "x2", "x3", "x19", "x20", "x21", "v0", "v1", "v2", "x29", "x30", "memory"
	);
    return out;
}

int setup_data(void) 
{
    int fd;
    char *path = "/root/safe_02/decrypted_file";
    fd = open(path, O_RDONLY);
    if (fd <= 0){
        fprintf(stderr, "can't open %s for reading\n", path);
        exit(-1);
    }
    struct stat st;
    if (fstat(fd, &st) < 0) {
        fprintf(stderr, "fstat error\n");
        exit(-1);
    }
    data_size = st.st_size;
    data = (char *)mmap(0, st.st_size, PROT_READ, MAP_SHARED | MAP_POPULATE, fd, 0);
    if (data <= 0) {
        fprintf(stderr, "failed to mmap\n");
        exit(-1);
    }
    return 0;
}

void print_mix_n_roll() 
{
    printf("\n- Mix'n'Roll -\n");
    printf(" [0x%x] : 0x%x\n", 0,  z0);
    printf(" [0x%x] : 0x%x\n", 1,  z1);
    printf(" [0x%x] : 0x%x\n", 2,  z2);
    printf(" [0x%x] : 0x%x\n", 3,  z3);
    printf(" [0x%x] : 0x%x\n", 4,  z4);
    printf(" [0x%x] : 0x%x\n", 5,  z5);
    printf(" [0x%x] : 0x%x\n", 6,  z6);
    printf(" [0x%x] : 0x%x\n", 7,  z7);
    printf(" [0x%x] : 0x%x\n", 8,  z8);
    printf(" [0x%x] : 0x%x\n", 9,  z9);
    printf(" [0x%x] : 0x%x\n", 10, za);
    printf(" [0x%x] : 0x%x\n", 11, zb);
    printf(" [0x%x] : 0x%x\n", 12, zc);
    printf(" [0x%x] : 0x%x\n", 13, zd);
    printf(" [0x%x] : 0x%x\n", 14, ze);
    printf("\n");
}

unsigned int LOWORD(unsigned int x) {
    return (x & 0xffff);
}

unsigned int HIWORD(unsigned int x) {
    return ((x >> 0x10) & 0xffff);
}

unsigned int REVWORD(unsigned int x) {
    return (x & 0xff) << 8 | (x >> 0x8) & 0xff;
}

void algo(void) 
{
    for (zc = 0; zc < 8; zc += 2) 
    {
        z0 = REVWORD(LOWORD(user[zc]));
        z1 = REVWORD(HIWORD(user[zc]));
        z2 = REVWORD(LOWORD(user[zc+1]));
        z3 = REVWORD(HIWORD(user[zc+1]));

        z7 = 0x7f;
        for (ze = 0x20; ze > 0; ze--)
        {
            z4 = (z1 >> 0x8) & 0xff;
            z5 = z1 & 0xff;
            z6 = kiwi(((z7-- % 0xa) << 0x10 | z5 << 0x8 | z4) + 0x1000) & 0xff;
            z5 = kiwi(((z7-- % 0xa) << 0x10 | z4 << 0x8 | z6) + 0x1000) & 0xff;
            z4 = kiwi(((z7-- % 0xa) << 0x10 | z6 << 0x8 | z5) + 0x1000) & 0xff;
            z6 = kiwi(((z7-- % 0xa) << 0x10 | z5 << 0x8 | z4) + 0x1000) & 0xff;
            z9 = z6 << 0x8 | z4;

            if ((((ze-1) >> 0x3) & 0x1) == 1){
                // z0, z1, z2, z3 = z9, ze ^ z9 ^ z2, z3, z0
                z8 = z0;
                z1 = ze ^ z9 ^ z2;
                z0 = z9;
                z2 = z3;
                z3 = z8;
            } else {
                // z0, z1, z2, z3 = z9, z2, z3, ze ^ z0 ^ z1
                z8 = z3;
                z3 = ze ^ z0 ^ z1;
                z0 = z9;
                z1 = z2;
                z2 = z8;
            }
        }
        user[zc]   = REVWORD(z1) << 0x10 | REVWORD(z0);
        user[zc+1] = REVWORD(z3) << 0x10 | REVWORD(z2);
    }
}

unsigned int kiwi_inv(unsigned int z7, unsigned int k_2, unsigned int out) 
{
    unsigned int k_1, i;
    unsigned int matches = 0;
    for (i = 0; i <= 0xff; i++) {
        if ((kiwi(((z7 & 0xff) << 0x10 | (i << 0x8) | k_2 & 0xff) + 0x1000) & 0xff) == (out & 0xff)) {
            matches += 1;
            k_1 = i;
        }
    }   
    if ((matches == 0) || (matches > 1)) {
        fprintf(stderr, "FAILED (matches == 0 OR matches > 1)");
        exit(-1);
    }
    return k_1;
}

void algo_inv(void) 
{
    for (zc = 8; zc > 0; zc -= 2) 
    {
        z0 = REVWORD(LOWORD(key[zc-2]));
        z1 = REVWORD(HIWORD(key[zc-2]));
        z2 = REVWORD(LOWORD(key[zc-1]));
        z3 = REVWORD(HIWORD(key[zc-1]));

        z7 = 0;
        for (ze = 0; ze <= 0x1f; ze++)
        {
            z6 = (z0 >> 0x8) & 0xff;
            z4 = (z0 & 0xff);
            
            z5 = kiwi_inv(z7++ % 0xa, z4, z6);
            z6 = kiwi_inv(z7++ % 0xa, z5, z4);
            z4 = kiwi_inv(z7++ % 0xa, z6, z5);
            z5 = kiwi_inv(z7++ % 0xa, z4, z6);
            z9 = (z4 & 0xff) << 0x8 | (z5 & 0xff);

            if (((ze >> 0x3) & 0x1) == 1) {
                // z0, z1, z2, z3 = z3, z9, z0 ^ z1 ^ (ze + 1), z2
                z8 = z3;
                z3 = z2;
                z2 = z0 ^ z1 ^ (ze + 1); 
                z1 = z9;
                z0 = z8;
            } else {
                // z0, z1, z2, z3 = z9 ^ z3 ^ (ze + 1), z9, z1, z2
                z8 = z2;
                z2 = z1;
                z1 = z9;
                z0 = z1 ^ z3 ^ (ze + 1);
                z3 = z8;
            }
        }
        key[zc-2] = LOWORD(REVWORD(z1)) << 0x10 | LOWORD(REVWORD(z0));
        key[zc-1] = LOWORD(REVWORD(z3)) << 0x10 | LOWORD(REVWORD(z2));
    }
}

int main(void) {

    setup_data();

    // algo();
    algo_inv();

    unsigned int i, j;
    for (i = 0; i < 8; i++) {
        for (j = 0; j < 4; j++) {
            unsigned char* p = (unsigned char *)&key[i];
            printf("%02x", p[j]);
        }
    }
    printf("\n");

    return 0;
}

// $ aarch64-linux-gnu-gcc -o 2 2.c -mcpu=cortex-a75 -march=armv8.2-a+sm4
// $ scp -P 5555 2 root@localhost:/root/
//
// # /root/2
// acadaa8b5b55306fb3c6dfc3b2d1c80770084644225febd71a9189aa26ec740e

